{
pixscale=0.111;

obj=$1;
nwrongword=0;
nwrongword+=gsub("/","",obj);
nwrongword+=gsub("*","",obj);
nwrongword+=gsub("&","",obj);
nwrongword+=gsub("%","",obj);
nwrongword+=gsub("?","",obj);
#nwrongword+=gsub("\[","",obj);
#nwrongword+=gsub("\]","",obj);
nwrongword+=gsub(";","",obj);
nwrongword+=gsub(":","",obj);
nwrongword+=gsub("#","",obj);
nwrongword+=gsub("!","",obj);
nwrongword+=gsub("[a-z]","[A-Z]",obj);
 
ra=$2;
dec=$3;
eq=$4;
pa=$5;
allfilter=$6;
allexp=$7;
allpat=$8;
alldith=$9;
allnframe=$10
mode=$11;
slit=$12;

#junk=pat
#matchim=gsub("IM",junk,junk);
#matchsp=gsub("SP",junk,junk);

nf=split(allfilter,filter,",");
nexp=split(allexp,exptime,",");
nn=split(allnframe,nframe,",");
ndith=split(alldith,dith,",");
np=split(allpat,pat,",");

dith2=int(dith[1]/0.105/10/4)*10;

if(nf!=nexp){
#  print("echo 'Error: Number of fields in column 6 and 7 should be same.'");
#  print("echo '# Warning: Number of fields in column 6 and 7 is different.'");
  if(nf>nexp) for(i=nexp+1;i<=nf;i++) exptime[i]=exptime[nexp];
#  exit 1;
}
if(nf!=nn){
#  print("echo 'Error: Number of fields in column 6 and 10 should be same.'");
#  exit 1;
#  print("echo '# Warning: Number of fields in column 6 and 10 is different.'");
  if(nf>nn) for(i=nn+1;i<=nf;i++) nframe[i]=nframe[nn];
}

if(nf!=ndith){
  if(nf>ndith){for(i=ndith+1;i<=nf;i++) dith[i]=dith[ndith];}
#  for(i=1;i<=nf;i++) dith[i]=dith[1];
}
if(nf!=np){
  if(nf>np) for(i=np+1;i<=nf;i++) pat[i]=pat[np];
#  for(i=1;i<=nf;i++) pat[i]=pat[1];
}
   
junk=allfilter
matchsp=gsub("Gr",junk,junk);
matchim=nf-matchsp

if(matchim>0){
  if(mode=="OBJ"){
      printf("\n");
      printf("## %s Imaging\n",obj);
      printf("# Setup\n");
      printf("ReSetupOBE $DEF_CISCO Filter=\"%s\"\n",filter[1]);
      printf("SetupField $DEF_IM $%s\n",obj);
      printf("GetSky $DEF_CISCO EXPTIME=%s FILTER=\"%s\" SLITX=125\n",exptime[1],filter[1]);
      printf("TelOffset $DEF_CISCO DX=0.0 DY=50.0\n");
      printf("TelOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");

    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])==0){
	  printf("# %s\n",filter[i]);
	  printf("CheckField $DEF_CISCO EXPTIME=%s FILTER=\"%s\"\n",exptime[i],filter[i]);
	  printf("GetObject $DEF_%s $%s NFRAME=%s DITH=%s\n",spat,obj,nframe[i],dith[i]);
	  for(j=2;j<=npat;j++){
	      if(j%4==0){dith2x=dith2; dith2y=0}
	      else if(j%4==1){dith2x=0; dith2y=dith2}
	      else if(j%4==2){dith2x=-1*dith2; dith2y=0}
	      else if(j%4==3){dith2x=0; dith2y=-1*dith2}
	      printf("TelOffset $DEF_CISCO DX=%.1f DY=%.1f\n",dith2x,dith2y);
	      printf("GetObject $DEF_%s $%s NFRAME=%s DITH=%s\n",spat,obj,nframe[i],dith[i]);
	  }
      }
    }
  }
  else if(mode=="STD"){
      printf("\n");
      printf("## Imaging Standard %s\n",obj);
      printf("SetupField $DEF_IM $%s\n",obj);
      printf("TelOffset $DEF_CISCO DX=0.0 DY=0.0\n");

    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit>1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])==0){
	  printf("CheckField $DEF_CISCO EXPTIME=%s FILTER=\"%s\"\n",exptime[i],filter[i]);
	  printf("GetStandard $DEF_%s $%s NFRAME=%s DITH=%s\n",spat,obj,nframe[i],dith[i]);
	  for(j=2;j<=npat;j++){
	      if(j%2==1) dith2y=dith2;
	      else  dith2y=-1*dith2;
	      printf("TelOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
	      printf("GetStandard $DEF_%s $%s NFRAME=%s DITH=%s\n",spat,obj,nframe[i],dith[i]);
	  }
      }
    }
  }
}

if(matchsp>0){
  if(mode=="OBJ"){
    for(i=1;i<=nf;i++){
       if(gsub("Gr","Gr",filter[i])>0) {
	 if(filter[i]=="wKGr")	 spimfilter="Kp";
	 else if(filter[i]=="JHGr")	 spimfilter="H";
	 else if(filter[i]=="zJGr")	 spimfilter="J";
	 break;
       }
    }
    printf("\n");
    printf("## %s Spectroscopy\n",obj);
    printf("# Setup\n");
    printf("ReSetupOBE $DEF_CISCO Filter=\"%s\"\n",spimfilter);
    printf("SetupField $DEF_IMV $%s I_BOTTOM=5500\n",obj);
    printf("AGCenter $DEF_CISCO\n");
    printf("GetSky $DEF_CISCO EXPTIME=20 NSAMPLE=1 FILTER=\"%s\" SLITX=125\n",spimfilter);
    printf("ProbeOffset $DEF_CISCO DX=0.0 DY=50.0\n");
    printf("ProbeOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");
    printf("AGOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");

    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
#Check the grism and set nsample=6 if zJGrism
      if(gsub("Gr","Gr",filter[i])>0){
	if(filter[i]=="zJGr") nsample=6;
	else nsample=1;
	printf("# %s, %s arcsec slit\n",filter[i],slit);
	printf("CheckField $DEF_CISCO EXPTIME=5 NSAMPLE=1 SLITX=2.0\n");
	printf("AGOffset $DEF_CISCO DX=0.0 DY=0.0\n");
	printf("CheckField $DEF_CISCO EXPTIME=5 NSAMPLE=1 SLITX=%s\n",slit);
	printf("CheckField $DEF_CISCO EXPTIME=20 NSAMPLE=1 FILTER=\"%s\"\n",filter[i]);
	printf("GetObject $DEF_%s $%s NFRAME=%s EXPTIME=%s NSAMPLE=%s DITH=%s\n",spat,obj,nframe[i],exptime[i],nsample,dith[i]);
	for(j=2;j<=npat;j++){
	    if(j%2==1) dith2y=dith2;
	    else  dith2y=-1*dith2;
	    printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
	    printf("GetObject $DEF_%s $%s NFRAME=%s EXPTIME=%s NSAMPLE=%s DITH=%s\n",spat,obj,nframe[i],exptime[i],nsample,dith[i]);
	}
      }
    }
  }
  else if(mode=="STD"){
    pixhalfslit=int(slit/2/pixscale);
    printf("\n");
    printf("## Spectroscopic Standard %s\n",obj);
    printf("#Setup\n");
    printf("SetupField $DEF_IM $%s\n",obj);
    printf("CATCHSAO $DEF_CISCO XCATCHSAOCENTERX\n");
    if(pat[1]=="IM2"){
      printf("CheckField $DEF_CISCO EXPTIME=%.1f NSAMPLE=1\n",exptime[1]);
      printf("TelOffset $DEF_CISCO DX=%s DY=0.0\n",pixhalfshift);
      printf("CheckField $DEF_CISCO\n");
    }
    else{
      printf("SetupField $DEF_IMV\n");
      printf("AGCenter $DEF_CISCO\n");
      printf("CheckField $DEF_CISCO EXPTIME=%.1f NSAMPLE=1\n",exptime[1]);
      printf("AGOffset $DEF_CISCO DX=%.1f DY=0.0\n",pixhalfslit);
      printf("CheckField $DEF_CISCO\n");
    }

    printf("# Get Standard\n");
    for(i=1;i<=nf;i++){
 #extract the number of iteration of dithering
      if(pat[i]!="SP4" && pat[i]!="SP2" && pat[i]!="IM2" && pat[i]!="SPABBA") pat[i]="SP4";
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])>0) {
	if(nf>1){
	  printf("# %s\n",filter[i]);
	  printf("CheckField $DEF_CISCO FILTER=\"%s\"\n",filter[i]);
	}
	printf("GetStandard $DEF_%s $%s NFRAME=%d DITH=%.1f\n",pat[i],obj,nframe[i],dith[i]);
	for(j=2;j<=npat;j++){
	  if(j%2==1) dith2y=dith2;
	  else  dith2y=-1*dith2;
	  printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
	  printf("GetStandard $DEF_%s $%s NFRAME=%d DITH=%.1f\n",pat[i],obj,nframe[i],dith[i]);
	}
      }
    }
  }
}
}
