{
obj=$1;
nwrongword=0;
nwrongword+=gsub("/","",obj);
nwrongword+=gsub("*","",obj);
nwrongword+=gsub("&","",obj);
nwrongword+=gsub("%","",obj);
nwrongword+=gsub("?","",obj);
#nwrongword+=gsub("\[","",obj);
#nwrongword+=gsub("\]","",obj);
nwrongword+=gsub(";","",obj);
nwrongword+=gsub(":","",obj);
nwrongword+=gsub("#","",obj);
nwrongword+=gsub("!","",obj);
nwrongword+=gsub("[a-z]","[A-Z]",obj);
ra=$2;
dec=$3;
eq=$4;
pa=$5;
allfilter=$6;
allexp=$7;
allpat=$8;
alldith=$9;
allnframe=$10
mode=$11;
slit=$12;

if(slit=="-"){
  slit=prevslit;
}

if(slit>0.5){
  slit="NORMAL";
  slit2="2.0";
  saoshift="-4.0"
  prevslit=1;
}
else if(slit<=0.5){
  slit="NARROW";
  slit2="1.5";
  saoshift="-2.0";
  prevslit=0.5;
}


dith2=int(dith[1]/0.105/10/4)*10;

nf=split(allfilter,filter,",");
nexp=split(allexp,exptime,",");
nn=split(allnframe,nframe,",");
ndith=split(alldith,dith,",");
np=split(allpat,pat,",");
if(nf!=nexp){
  if(nf>nexp) for(i=nexp+1;i<=nf;i++) exptime[i]=exptime[nexp];
#  print("echo 'Error: Number of fields in column 6 and 7 should be same.'");
#  exit 1;
}
if(nf!=nn){
  if(nf>nn) for(i=nn+1;i<=nf;i++) nframe[i]=nframe[nn];
#  print("echo 'Error: Number of fields in column 6 and 10 should be same.'");
#  exit 1;
}
   
if(nf!=ndith){
  if(nf>ndith){for(i=ndith+1;i<=nf;i++) dith[i]=dith[ndith];}
#  for(i=1;i<=nf;i++) dith[i]=dith[1];
}
if(nf!=np){
  if(nf>np) for(i=np+1;i<=nf;i++) pat[i]=pat[np];
#  for(i=1;i<=nf;i++) pat[i]=pat[1];
}

junk=allfilter
matchsp=gsub("Gr",junk,junk);
matchim=nf-matchsp

for(i=1;i<=np;i++){
  if(pat[i]=="IM4" || pat[i]=="IM8") pat[i]="IM2";
}
if(np<nf) {
  for(i=np+1;i<=nf;i++) pat[i]=pat[np];
}

if(matchim>0){
    if(mode=="OBJ"){
	printf("\n");
	printf("## %s OHS Imaging\n",obj);
	printf("#FOCUS & Pointing Check\n");
	printf("ReSetupOBE $DEF_OHS Filter=\"%s\"\n",filter[1]);
	printf("SetupField $DEF_IM $%s\n",obj);
	printf("TelOffsetByVGW $DEF_CISCO\n");
	printf("TelOffsetByQDAS $DEF_CISCO SKYSUB=OFF EXPTIME=2 SLITX=30.0 FILTER=\"H\"\n");
	printf("#Setup\n");
	printf("SetupField $DEF_IMV $%s I_BOTTOM=5500\n",obj);
	printf("AGCenter $DEF_CISCO\n");
	printf("GetSky $DEF_CISCO EXPTIME=20 NSAMPLE=1 FILTER=\"H\" SLITX=30.0\n");
	printf("ProbeOffset $DEF_CISCO DX=0.0 DY=50.0\n");
	printf("ProbeOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");
	printf("AGOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");
	
	for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
	    nsplit=split(pat[i],temp,"*");
	    spat=temp[1]; 
	    if(nsplit > 1) npat=temp[2];
	    else npat=1;
	    if(filter[i]=="H" || filter[i]=="J"){
		printf("# %s\n",filter[i]);
		printf("CheckField $DEF_CISCO EXPTIME=%.1d FILTER=\"%s\"\n",exptime[i],filter[i]);
		printf("GetObject $DEF_%s $%s NFRAME=%d DITH=%.1f\n",spat,obj,nframe[i],dith[i]);
		printf("OHSQL $DEF_OHS\n");
		for(j=2;j<=npat;j++){
		    if(j%2==1) dith2y=dith2;
		    else  dith2=-1*dith2;
		    printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
		    printf("GetObject $DEF_%s $%s NFRAME=%d DITH=%.1f\n",spat,obj,nframe[i],dith[i]);
		    printf("OHSQL $DEF_OHS\n");
		}
	    }
	}
    }
    else if(mode=="STD"){
	printf("\n");
	printf("## Imaging Standard %s\n",obj);
	printf("# Setup\n");
	printf("ReSetupOBE $DEF_OHS Filter=\"%s\"\n",filter[1]);
	printf("SetupField $DEF_IM $%s\n",obj);
	printf("TelOffsetByQDAS $DEF_CISCO SKYSUB=OFF EXPTIME=%.1f FILTER=\"%s\" SLITX=30.0\n",exptime[1],filter[1]);
	
	for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
	  nsplit=split(pat[i],temp,"*");
	  spat=temp[1]; 
	  if(nsplit > 1) npat=temp[2];
	  else npat=1;
	  if(filter[i]=="H" || filter[i]=="J"){
	    printf("# %s\n",filter[i]);
	    printf("GetStandard $DEF_%s $%s NFRAME=%s DITH=%s EXPTIME=%s FILTER=\"%s\"\n","IM2",obj,nframe[i],dith[i],exptime[i],filter[i]);
	    for(j=2;j<=npat;j++){
		if(j%2==1) dith2y=dith2;
		else  dith2=-1*dith2;
		printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
		printf("GetStandard $DEF_%s $%s NFRAME=%s DITH=%s EXPTIME=%s FILTER=\"%s\"\n","IM2",obj,nframe[i],dith[i],exptime[i],filter[i]);
	    }
	  }
	}
    }
}

if(matchsp>0){
  if(mode=="OBJ"){
    spimfilter="H";
    printf("\n");
    printf("## %s OHS Spectroscopy\n",obj);
    printf("#FOCUS & Pointing Check\n");
    printf("ReSetupOBE $DEF_OHS Filter=\"H\"\n");
    printf("SetupField $DEF_IM $%s\n",obj);
    printf("TelOffsetByVGW $DEF_CISCO\n");
    printf("TelOffsetByQDAS $DEF_CISCO SKYSUB=OFF EXPTIME=2 SLITX=30.0 FILTER=\"H\"\n");
    printf("# Setup\n");
    printf("ReSetupOBE $DEF_OHS Filter=\"H\"\n");
    printf("SetupField $DEF_IMV $%s I_BOTTOM=5500\n",obj);
    printf("AGCenter $DEF_CISCO\n");
    printf("GetSky $DEF_CISCO EXPTIME=20 NSAMPLE=1 FILTER=\"H\" SLITX=30.0\n");
    printf("ProbeOffset $DEF_CISCO DX=0.0 DY=50.0\n");
    printf("ProbeOffsetByQDAS $DEF_CISCO SKYSUB=ON\n");
    printf("GetObject $DEF_SP2 $%s EXPTIME=50 NFRAME=3 DITH=%s SLITX=30.0 FILTER=\"%s\" NSAMPLE=1\n",obj,dith[1],spimfilter);
    printf("OHSQL $DEF_OHS\n");
    printf("AGOffset $DEF_CISCO DX=0.0 DY=0.0\n");
    printf("GetObject $DEF_SP2 $%s NFRAME=3 DITH=%s\n",obj,dith[1]);
    printf("OHSQL $DEF_OHS\n");

    for(i=1;i<=nf;i++){
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])>0){
	  printf("# %s, %s slit\n",filter[i],slit);
	  printf("OHSSlit $DEF_OHS SELECT=%s XOFFSET=0.0\n",slit);	  
	  printf("CheckField $DEF_CISCO EXPTIME=10 NSAMPLE=1\n");	  
	  printf("CheckField $DEF_CISCO EXPTIME=10 NSAMPLE=1 SLITX=%s\n",slit2); 
	  printf("CISCOSlit $DEF_OHS DX=0.0\n");	  
	  printf("CheckField $DEF_CISCO\n"); 
	  printf("CheckField $DEF_CISCO EXPTIME=20 NSAMPLE=1 FILTER=\"%s\"\n",filter[i]);	  
      }

      if(gsub("Gr","Gr",filter[i])>0){
	  printf("GetObject $DEF_%s $%s NFRAME=%d EXPTIME=%.1f NSAMPLE=6 DITH=%s\n",spat,obj,nframe[i],exptime[i],dith[i]);
	  for(j=2;j<=npat;j++){
	      if(j%2==1) dith2y=dith2;
	      else  dith2y=-1*dith2;
		printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
		printf("GetObject $DEF_%s $%s NFRAME=%d EXPTIME=%.1f NSAMPLE=6 DITH=%s\n",spat,obj,nframe[i],exptime[i],dith[i]);
	  }
      }
    }
  }
  else if(mode=="STD"){
    printf("\n");
    printf("## Spectroscopic Standard %s\n",obj);
    printf("#Setup\n");
    printf("SetupField $DEF_IM $%s\n",obj);
    printf("CATCHSAO $DEF_CISCO XCATCHSAOCENTERX\n");
    if(pat[1]=="IM2"){
      printf("CheckField $DEF_CISCO EXPTIME=%.1f NSAMPLE=1\n",exptime[1]);
      printf("TelOffset $DEF_CISCO DX=%s DY=0.0\n",saoshift);
      printf("CheckField $DEF_CISCO\n");
    }
    else{
      printf("SetupField $DEF_IMV\n");
      printf("AGCenter $DEF_CISCO\n");
      printf("CheckField $DEF_CISCO EXPTIME=%.1f NSAMPLE=1\n",exptime[1]);
      printf("AGOffset $DEF_CISCO DX=%s DY=0.0\n",saoshift);
      printf("CheckField $DEF_CISCO\n");
    }
    
    printf("# Get Standard\n");
    for(i=1;i<=nf;i++){
      if(pat[i]!="SP4" && pat[i]!="SP2" && pat[i]!="IM2" && pat[i]!="SPABBA") pat[i]="SP4";
      printf("# %s\n",filter[i]);
#extract the number of iteration of dithering
      nsplit=split(pat[i],temp,"*");
      spat=temp[1]; 
      if(nsplit > 1) npat=temp[2];
      else npat=1;
      if(gsub("Gr","Gr",filter[i])>0) {
	printf("GetStandard $DEF_%s $%s NFRAME=%d DITH=%.1f\n",pat[i],obj,nframe[i],dith[i]);
	for(j=2;j<=npat;j++){
	  if(j%2==1) dith2y=dith2;
	  else  dith2y=-1*dith2;
	  printf("AGOffset $DEF_CISCO DX=0.0 DY=%.1f\n",dith2y);
	  printf("GetStandard $DEF_%s $%s NFRAME=%d DITH=%.1f\n",pat[i],obj,nframe[i],dith[i]);
	}
      }
    }
  }
}
}
